#include <tos.h>
#include <stdio.h>

/* Return the length in bytes or 0 on failure */
long file_length(const char *fname)
{
	int fildes;
	long length=0;
	
	fildes=open(fname,O_RDONLY);
	if (fildes>=0)
	{
		length=lseek(fildes,0L,SEEK_END);
		close(fildes);
	}
	
	return length;
}

int load(const char *fname, void *start, long length)
{
	int f=0,fildes;
	
	fildes=open(fname,O_RDONLY);
	if (fildes>=0)
	{
		read(fildes,start,length);
		close(fildes);
	}
	else f=1;
	
	return f;
}

int save(const char *fname, void *start, long length)
{
	int f=0;
	long handle,ret;
	
	handle=Fcreate(fname,0);
	if (handle>=0)
	{
		ret=Fwrite((int)handle,length,start);
		if (ret<0) f=1;
		else Fclose((int)handle);
	}
	else f=1;
	
	return f;
}
/*
int save(const char *fname, FILE_INFO *fi){
	int handle;
	
	handle=open(fname, O_WRONLY|O_CREAT|O_TRUNC);
	if(handle==TRUE) return TRUE;
	if(write(handle, fi->start, fi->size)!=fi->size) return TRUE;
	if(close(handle)==TRUE) return TRUE;
	
	return FALSE;
}
*/